<?php

namespace app\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use app\models\Artbook;

/**
 * ArtbookSearch represents the model behind the search form about `app\models\Artbook`.
 */
class ArtbookSearch extends Artbook
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['artbook_id', 'create_time', 'create_user', 'update_time', 'update_user', 'record_date'], 'integer'],
            [['artbook_sid', 'artbook_loc', 'artbook_pid', 'artbook_q1', 'status'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = Artbook::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'artbook_id' => $this->artbook_id,
            'create_time' => $this->create_time,
            'create_user' => $this->create_user,
            'update_time' => $this->update_time,
            'update_user' => $this->update_user,
            'record_date' => $this->record_date,
        ]);

        $query->andFilterWhere(['like', 'artbook_sid', $this->artbook_sid])
            ->andFilterWhere(['like', 'artbook_loc', $this->artbook_loc])
            ->andFilterWhere(['like', 'artbook_pid', $this->artbook_pid])
            ->andFilterWhere(['like', 'artbook_q1', $this->artbook_q1])
            ->andFilterWhere(['like', 'status', $this->status]);

        return $dataProvider;
    }
}
